package edu.ntnu.stud.chaosgame;

import edu.ntnu.stud.chaosgame.game.ChaosGameDescription;
import edu.ntnu.stud.chaosgame.game.ChaosGameFileHandler;
import edu.ntnu.stud.chaosgame.model.Matrix2x2;
import edu.ntnu.stud.chaosgame.model.Vector2D;
import edu.ntnu.stud.chaosgame.model.handling.ChaosCanvas;
import edu.ntnu.stud.chaosgame.model.handling.ChaosGame;
import edu.ntnu.stud.chaosgame.model.transformations.AffineTransform2D;
import edu.ntnu.stud.chaosgame.model.transformations.Transform2D;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.Objects;
import java.util.Scanner;

/**
 * Main class for the Chaos Game application.
 */
public class Main {

  public static void main(String[] args) throws IOException {
    Scanner sc = new Scanner(System.in);
    System.out.println("Hi");
    String path = "src/main/resources/descriptions/sierpinski.txt";

    ChaosGameDescription description = null; // Declare description

    ChaosGame game = null;

    try {
      //ChaosGameDescription description = new ChaosGameFileHandler().readFromFile(path);
      //description = new ChaosGameDescription(minCoords, maxCoords, transforms);
      description = new ChaosGameFileHandler().readFromFile(path);
      ChaosCanvas canvas = new ChaosCanvas(100, 100, description.getMinCoords(), description.getMaxCoords()); // Create canvas
      game = new ChaosGame(description, canvas);

    } catch (Exception e) {
      System.out.println(e.getMessage()); // TODO: Alter error handling
    }

    boolean exit = false;

    // While loop for simple cli-app.
    while (!exit) {

      System.out.println("What would you like to do? Type 1 for displaying fractal, "
          + "or anything else for ending the program");
      if (Objects.equals(sc.next(), "1")) {
        game.runSteps(100000);
        System.out.println(
            "What would you like to do? Type 1 for saving the fractal, anything else for ending the program");

        if (Objects.equals(sc.next(), "1")) {
          ChaosGameFileHandler handler = new ChaosGameFileHandler();
          handler.writeToFile(description, "src/main/resources/descriptions/output.txt");
          System.out.println("Wrote to file output.txt.");
        }
        else {
          exit = true;
        }
      }
      else {
        exit = true;
      }
    }
    System.out.println("Terminated program.");




  }
}